
@interface HelperClass: NSObject

+ (BOOL)shouldContinueWithPrompt:(NSString *)prompt;
+ (NSArray *)returnForProcess:(NSString *)call;
+ (InputPackage *)packageForDeb:(NSString *)debFile;
+ (NSString *)octalFromSymbols:(NSString *)theSymbols;
+ (NSString *)octalFromGroupSymbols:(NSString *)theSymbols;
+ (NSString *)numberedArrayFromStatusFile:(NSString *)statusFile bootstrapPath:(NSString *)boostrapPath;
+ (NSArray <StatusPackageModel*>*)statusInstalledPackagesFromFile:(NSString *)statusFile;
+ (NSArray <StatusPackageModel*>*)statusInstalledPackagesFromFile:(NSString *)statusFile bootstrapPath:(NSString *)bootstrapPath;
+ (NSString *)singleLineReturnForProcess:(NSString *)format, ...;
+ (NSArray *)arrayReturnForTask:(NSString *)taskBinary withArguments:(NSArray *)taskArguments;
+ (void)runProcess:(NSString *)call environment:(NSDictionary *)env currentPath:(NSString *)currentPath completion:(void(^)(NSString *output, NSInteger returnStatus))block;
+ (int)runCommand:(NSString *)call environment:(NSDictionary *)env currentPath:(NSString *)currentPath verbose:(BOOL)verbose;
+ (NSString *)validLDIDPath;
+ (int)bumpPackageAtPath:(NSString *)debFile withPrefix:(NSString *)prefix sigChecks:(BOOL)skip excludeFile:(NSString *)excludeFile;
+ (int)repackagePackageAtPath:(NSString *)debFile withPrefix:(NSString *)prefix sigChecks:(BOOL)skip arch:(NSString *)arch excludeFile:(NSString *)excludeFile;
+ (int)cleanBootstrapAtPath:(NSString *)bootstrapPath;
+ (int)deletePackage:(NSString *)deletePackage inBootstrap:(NSString *)bootstrapPath;
+ (int)createNewBootstrap:(NSString *)bootstrapPath withPackages:(NSString *)packagesFolder;
+ (NSInteger)getNumberFromPrompt:(NSString *)prompt;
+ (InputPackageFile *)packageFileFromLine:(NSString *)inputLine;
@end
