
//the input deb file that is processing

//#import "InputPackageFile.h"

@class InputPackageFile;

@interface InputPackage: NSObject

@property (nonatomic, strong) NSArray <InputPackageFile *> *files;
@property (nonatomic, strong) NSArray  *controlFiles;
@property (nonatomic, strong) NSString *packageName;
@property (nonatomic, strong) NSString *version;
@property (nonatomic, strong) NSString *architecture;
@property (nonatomic, strong) NSString *path;
@property (nonatomic, strong) NSString *appendedPrefix;
@property (readwrite, assign) BOOL skipSignatureChecks;
@property (readwrite, assign) BOOL forceOverwrite;
@property (readwrite, assign) BOOL forceInstall;
@property (readwrite, assign) BOOL unpack;
@property (nonatomic, strong) NSString *validLDIDPath;
@property (nonatomic, strong) NSString *arch; //if repackaging.
@property (nonatomic, strong) NSString *excludeFile;
@property (nonatomic, strong) NSArray *excludedFiles; //created from excluded file during package installation


- (void)bumpVersionInCurrentDirectory;
- (void)repackageInCurrentDirectoryWithArch:(NSString *)newArch;
- (int)installToBootstrapPath:(NSString *)bootstrapPath;
- (ErrorReturn *)errorReturnForBootstrap:(NSString *)bootstrapPath;
- (NSString *)listfile;
- (NSArray *)rootPaths;
+ (InputPackage *)packageForDeb:(NSString *)debFile;
+ (InputPackage *)packageForDeb:(NSString *)debFile excludes:(NSString *)excludesFile;
@end
