//
//  Universalize.m
//  bootstrapTool
//
//  Created by Kevin Bradley on 10/31/19.
//  Copyright © 2019 nito. All rights reserved.
//

#include <Foundation/Foundation.h>
#include <mach-o/loader.h>
#import "Universalize.h"

@implementation Universalize

+ (int)universalize:(NSString *)path {
    
    int fd = open([path UTF8String], O_RDWR);
    if (fd < 0) {
        perror("open");
        return -2;
    }
    char header[4096];
    struct mach_header_64* mh = (struct mach_header_64*)header;
    if (4096 != pread(fd, header, 4096, 0))
    {
        perror("read");
        return -3;
    }
    BOOL patched = false;
    struct load_command* lc = (struct load_command*)(mh + 1);
    for (int i = 0; i < mh->ncmds; i++) {
        if (lc->cmd == LC_VERSION_MIN_IPHONEOS) {
            puts("patching");
            patched = true;
            lc->cmd = LC_VERSION_MIN_TVOS;
        } else if (lc->cmd == LC_BUILD_VERSION) {
            struct build_version_command *bvc = (struct build_version_command*)lc;
            if (bvc->platform == PLATFORM_IOS){
                puts("patching");
                bvc->platform = PLATFORM_TVOS;
                patched = true;
            }
        }
        lc = (struct load_command*)(((char*)lc) + lc->cmdsize);
    }
    if (4096 != pwrite(fd, header, 4096, 0))
    {
        perror("write");
        return -4;
    }
    if (patched){
        return 1;
    }
    return 0;
}

@end



